<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderItemShipmentInfo StructType
 * @subpackage Structs
 */
class OrderItemShipmentInfo extends AbstractStructBase
{
    /**
     * The shipmentCompany
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\ShipmentCompanyData
     */
    public $shipmentCompany;
    /**
     * The trackingNumber
     * @var string
     */
    public $trackingNumber;
    /**
     * The trackingNumberStatus
     * @var string
     */
    public $trackingNumberStatus;
    /**
     * The shipmentCode
     * @var int
     */
    public $shipmentCode;
    /**
     * The campaignNumber
     * @var string
     */
    public $campaignNumber;
    /**
     * The shipmentMethod
     * @var string
     */
    public $shipmentMethod;
    /**
     * The campaignNumberStatus
     * @var int
     */
    public $campaignNumberStatus;
    /**
     * Constructor method for OrderItemShipmentInfo
     * @uses OrderItemShipmentInfo::setShipmentCompany()
     * @uses OrderItemShipmentInfo::setTrackingNumber()
     * @uses OrderItemShipmentInfo::setTrackingNumberStatus()
     * @uses OrderItemShipmentInfo::setShipmentCode()
     * @uses OrderItemShipmentInfo::setCampaignNumber()
     * @uses OrderItemShipmentInfo::setShipmentMethod()
     * @uses OrderItemShipmentInfo::setCampaignNumberStatus()
     * @param \StructType\ShipmentCompanyData $shipmentCompany
     * @param string $trackingNumber
     * @param string $trackingNumberStatus
     * @param int $shipmentCode
     * @param string $campaignNumber
     * @param string $shipmentMethod
     * @param int $campaignNumberStatus
     */
    public function __construct(\StructType\ShipmentCompanyData $shipmentCompany = null, $trackingNumber = null, $trackingNumberStatus = null, $shipmentCode = null, $campaignNumber = null, $shipmentMethod = null, $campaignNumberStatus = null)
    {
        $this
            ->setShipmentCompany($shipmentCompany)
            ->setTrackingNumber($trackingNumber)
            ->setTrackingNumberStatus($trackingNumberStatus)
            ->setShipmentCode($shipmentCode)
            ->setCampaignNumber($campaignNumber)
            ->setShipmentMethod($shipmentMethod)
            ->setCampaignNumberStatus($campaignNumberStatus);
    }
    /**
     * Get shipmentCompany value
     * @return \StructType\ShipmentCompanyData|null
     */
    public function getShipmentCompany()
    {
        return $this->shipmentCompany;
    }
    /**
     * Set shipmentCompany value
     * @param \StructType\ShipmentCompanyData $shipmentCompany
     * @return \StructType\OrderItemShipmentInfo
     */
    public function setShipmentCompany(\StructType\ShipmentCompanyData $shipmentCompany = null)
    {
        $this->shipmentCompany = $shipmentCompany;
        return $this;
    }
    /**
     * Get trackingNumber value
     * @return string|null
     */
    public function getTrackingNumber()
    {
        return $this->trackingNumber;
    }
    /**
     * Set trackingNumber value
     * @param string $trackingNumber
     * @return \StructType\OrderItemShipmentInfo
     */
    public function setTrackingNumber($trackingNumber = null)
    {
        // validation for constraint: string
        if (!is_null($trackingNumber) && !is_string($trackingNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($trackingNumber, true), gettype($trackingNumber)), __LINE__);
        }
        $this->trackingNumber = $trackingNumber;
        return $this;
    }
    /**
     * Get trackingNumberStatus value
     * @return string|null
     */
    public function getTrackingNumberStatus()
    {
        return $this->trackingNumberStatus;
    }
    /**
     * Set trackingNumberStatus value
     * @param string $trackingNumberStatus
     * @return \StructType\OrderItemShipmentInfo
     */
    public function setTrackingNumberStatus($trackingNumberStatus = null)
    {
        // validation for constraint: string
        if (!is_null($trackingNumberStatus) && !is_string($trackingNumberStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($trackingNumberStatus, true), gettype($trackingNumberStatus)), __LINE__);
        }
        $this->trackingNumberStatus = $trackingNumberStatus;
        return $this;
    }
    /**
     * Get shipmentCode value
     * @return int|null
     */
    public function getShipmentCode()
    {
        return $this->shipmentCode;
    }
    /**
     * Set shipmentCode value
     * @param int $shipmentCode
     * @return \StructType\OrderItemShipmentInfo
     */
    public function setShipmentCode($shipmentCode = null)
    {
        // validation for constraint: int
        if (!is_null($shipmentCode) && !(is_int($shipmentCode) || ctype_digit($shipmentCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($shipmentCode, true), gettype($shipmentCode)), __LINE__);
        }
        $this->shipmentCode = $shipmentCode;
        return $this;
    }
    /**
     * Get campaignNumber value
     * @return string|null
     */
    public function getCampaignNumber()
    {
        return $this->campaignNumber;
    }
    /**
     * Set campaignNumber value
     * @param string $campaignNumber
     * @return \StructType\OrderItemShipmentInfo
     */
    public function setCampaignNumber($campaignNumber = null)
    {
        // validation for constraint: string
        if (!is_null($campaignNumber) && !is_string($campaignNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($campaignNumber, true), gettype($campaignNumber)), __LINE__);
        }
        $this->campaignNumber = $campaignNumber;
        return $this;
    }
    /**
     * Get shipmentMethod value
     * @return string|null
     */
    public function getShipmentMethod()
    {
        return $this->shipmentMethod;
    }
    /**
     * Set shipmentMethod value
     * @param string $shipmentMethod
     * @return \StructType\OrderItemShipmentInfo
     */
    public function setShipmentMethod($shipmentMethod = null)
    {
        // validation for constraint: string
        if (!is_null($shipmentMethod) && !is_string($shipmentMethod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shipmentMethod, true), gettype($shipmentMethod)), __LINE__);
        }
        $this->shipmentMethod = $shipmentMethod;
        return $this;
    }
    /**
     * Get campaignNumberStatus value
     * @return int|null
     */
    public function getCampaignNumberStatus()
    {
        return $this->campaignNumberStatus;
    }
    /**
     * Set campaignNumberStatus value
     * @param int $campaignNumberStatus
     * @return \StructType\OrderItemShipmentInfo
     */
    public function setCampaignNumberStatus($campaignNumberStatus = null)
    {
        // validation for constraint: int
        if (!is_null($campaignNumberStatus) && !(is_int($campaignNumberStatus) || ctype_digit($campaignNumberStatus))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($campaignNumberStatus, true), gettype($campaignNumberStatus)), __LINE__);
        }
        $this->campaignNumberStatus = $campaignNumberStatus;
        return $this;
    }
}
